<?php

  class mw_agenda_admin extends mw_mod
  {

    function index(&$env)
    { $data = $env->data();
      if(($agenda = $data->list_agenda(array("order_by" => "debut", "order" => "DESC"))) !== false)
      { foreach($agenda["list"] as $id_item => $item)
        { $agenda["list"][$id_item]["contenu"] = $item["contenu"];
        }
        $env->set_out("agenda", $agenda);
      }
      else $env->erreur("impossible de lire de contenu de l'agenda");
    }

    function validate_POST_item(&$env, $item = null)
    { $item = isset($item) ? $item : array();
      if($_POST)
      { $date_debut = trim($_POST["date_debut"]);
        $heure_debut = trim($_POST["heure_debut"]);
        $minute_debut = trim($_POST["minute_debut"]);
        $debut = $date_debut." ".$heure_debut.":".$minute_debut.":00";
        $date_fin = trim($_POST["date_fin"]);
        $heure_fin = trim($_POST["heure_fin"]);
        $minute_fin = trim($_POST["minute_fin"]);
        $fin = $date_fin." ".$heure_fin.":".$minute_fin.":00";
        $item["debut"] = $debut;
        $item["fin"] = $fin;
        $item["contenu"] = $_POST["contenu"];
        if($date_debut)
        { if(preg_match("/^\d{4}-\d{2}-\d{2} [0-2][0-9]:[0-5][0-9]:[0-5][0-9]$/", $debut))
          { $item["debut"] = $debut;
            $item["date_debut"] = $date_debut;
            $item["heure_debut"] = $heure_debut;
            $item["minute_debut"] = $minute_debut;
          }
          else $env->message("le format de la date de debut est incorrect");
        }
        else $env->message("merci de preciser une date de debut");
        if($date_fin)
        { if(preg_match("/^\d{4}-\d{2}-\d{2} [0-2][0-9]:[0-5][0-9]:[0-5][0-9]$/", $fin))
          { $item["fin"] = $fin;
            $item["date_fin"] = $date_fin;
            $item["heure_fin"] = $heure_fin;
            $item["minute_fin"] = $minute_fin;
          }
          else $env->message("le format de la date de fin est incorrect");
        }
        else $env->message("merci de preciser une date de fin");
      }
      else $env->message("pas de donnees POST");
      return $item;
    }

    function add(&$env)
    { $data = $env->data();
      $item = array();
      if($_POST)
      { $item = $this->validate_POST_item($env);
        if(!$env->messages())
        { if
          ( ( $id_item = $data->add_agenda
              ( $item["debut"],
                $item["fin"],
                $item["contenu"]
              )
            ) !== false
          )
          { $env->redirect
            ( $env->url("agenda/admin"),
              "l'element a &eacute;t&eacute; ajout&eacute; &agrave; l'agenda"
            );
          }
          else $env->erreur("impossible d'ajouter l'element &agrave; l'agenda");
        }
      }
      $env->set_out("item", $item);
    }

    function edit(&$env)
    { $data = $env->data();
      if(($item = $data->get_agenda($_GET[$env->param("id")])) !== false)
      { if($_POST)
        { $item = $this->validate_POST_item($env, $item);
          if(!$env->messages())
          { if
            ( $data->set_agenda
              ( $item["id"],
                $item["debut"],
                $item["fin"],
                $item["contenu"]
              )
            )
            { $env->redirect
              ( $env->url("agenda/admin"),
                "l'element a &eacute;t&eacute; modifi&eacute;"
              );
            }
            else $env->erreur("impossible de modifier l'element");
          }
        }
        $env->set_out("item", $item);
      }
      else $env->erreur("impossible de lire les informations de cet element dans l'agenda");
    }

    function del(&$env)
    { $data = $env->data();
      if(($item = $data->get_agenda($_GET[$env->param("id")])) !== false)
      { if($data->del_agenda($item["id"]))
        { $env->redirect
          ( $env->url("agenda/admin"),
            "l'element a &eacute;t&eacute; supprim&eacute;"
          );
        }
        else $env->erreur("Impossible de supprimer l'utilisateur");
      }
      else $env->erreur("impossible de lire les informations de cet element dans l'agenda");
    }

  }

?>