<?php

  class mw_agenda_view extends mw_mod
  {

    function index(&$env)
    {
      /*
        preparation des parametres pour le listing des evenements
      */
      $params = array("order_by" => "debut", "order" => "DESC");

      // les evenements depuis...
      if(isset($_GET[$env->param("debut")]))
      { $debut = trim($_GET[$env->param("debut")]);
        if(preg_match("/^\d{4}-\d{2}-\d{2} [0-2][0-3]:[0-5][0-9]:[0-5][0-9]$/", $debut))
        { $params["debut"] = $debut;
        }
      }

      // les evenements jusqu'a...
      if(isset($_GET[$env->param("fin")]))
      { $fin = trim($_GET[$env->param("fin")]);
        if(preg_match("/^\d{4}-\d{2}-\d{2} [0-2][0-3]:[0-5][0-9]:[0-5][0-9]$/", $fin))
        { $params["fin"] = $fin;
        }
      }

      /*
        appel aux modules de donnees pour recuperer les informations
        en base
      */
      $data = $env->data();
      if(($agenda = $data->list_agenda($params)) !== false)
      { /*
          si tout va bien, on prepare les infos pour l'affichage
        */
        $env->set_out("agenda", $agenda);
      }
      else
      { /*
          sinon on declare une erreur
        */
        $env->erreur("impossible de lire de contenu de l'agenda");
      }
    }

  }

?>